27d633e702767af606e951127b6f16fcce79cefc
[asterisk/asterisk.git] / contrib / init.d / rc.redhat.asterisk
1 #!/bin/sh
2 # $Id$
3 #
4 # asterisk    Starts, Stops and Reloads Asterisk.
5 #
6 # chkconfig: 2345 90 60
7 # description: Asterisk PBX and telephony daemon.
8 # processname: asterisk
9 # pidfile: /var/run/asterisk.pid
10 #
11 # Thu Nov 17 2005 Gregory Boehnlein <damin@nacs.net>
12 # - Updated Version to 1.3
13 # - Reversed behavior of LD_ASSUME_KERNEL=2.4.1
14 # - Added detailed failure messages
15 #
16 # Sun Jul 18 2004 Gregory Boehnlein <damin@nacs.net>
17 # - Updated Version to 1.2
18 # - Added test for safe_asterisk
19 # - Verified SIGTERM issued by "killproc" ensures "stop gracefully"
20 # - Added support for -U and -G command line options
21 # - Modified "reload" to call asterisk -rx 'reload' 
22
23 # Use this option to specify a different configuration directory
24 #AST_CONFIG=/etc/asterisk
25
26 # Installation directory
27 AST_SBIN=/usr/sbin
28
29 # Uncomment the following and set them to the user/groups that you
30 # want to run Asterisk as. NOTE: this requires substantial work to
31 # be sure that Asterisk's environment has permission to write the
32 # files required  for  its  operation, including logs, its comm
33 # socket, the asterisk database, etc.
34 #AST_USER="asterisk"
35 #AST_GROUP="asterisk"
36
37 # Source function library.
38 . /etc/rc.d/init.d/functions
39
40 if ! [ -x $AST_SBIN/asterisk ] ; then
41         echo "ERROR: $AST_SBIN/asterisk not found"
42         exit 0
43 fi
44
45 if ! [ -d $AST_CONFIG ] ; then
46         echo "ERROR: $AST_CONFIG directory not found"
47         exit 0
48 fi
49
50 # Uncomment this ONLY if you know what you are doing.
51 # export LD_ASSUME_KERNEL=2.4.1
52
53 # Full path to asterisk binary
54 DAEMON=$AST_SBIN/asterisk
55
56 # Full path to safe_asterisk script
57 SAFE_ASTERISK=$AST_SBIN/safe_asterisk
58
59 # Allow configuration overrides in /etc/sysconfig/asterisk
60 CONFIG0=`readlink $0`
61 if [ "$CONFIG0" = "" ]; then
62         CONFIGFILE=/etc/sysconfig/`basename $0`
63 else
64         CONFIGFILE=/etc/sysconfig/`basename $CONFIG0`
65 fi
66 [ -x $CONFIGFILE ] && . $CONFIGFILE
67
68 RETVAL=0
69
70 start() {
71         # Start daemons.
72         echo -n $"Starting asterisk: "
73         if [ -f $SAFE_ASTERISK ] ; then
74                 DAEMON=$SAFE_ASTERISK
75         fi
76         if [ $AST_USER ] ; then
77                 ASTARGS="-U $AST_USER"
78         fi
79         if [ $AST_GROUP ] ; then
80                 ASTARGS="$ASTARGS -G $AST_GROUP"
81         fi
82         if [ $AST_CONFIG ]; then
83                 ASTARGS="$ASTARGS -C $AST_CONFIG"
84         fi
85         daemon $DAEMON $ASTARGS
86         RETVAL=$?
87         [ $RETVAL -eq 0 ] && touch /var/lock/subsys/asterisk
88         echo
89         return $RETVAL
90 }
91
92 stop() {
93         # Stop daemons.
94         echo -n $"Shutting down asterisk: "
95         killproc asterisk
96         RETVAL=$?
97         [ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/asterisk
98         echo
99         return $RETVAL
100 }
101
102 restart() {
103         stop
104         start
105 }
106
107 reload() {
108         $DAEMON -rx 'reload' > /dev/null 2> /dev/null
109 }
110
111 # See how we were called.
112 case "$1" in
113   start)
114         start
115         ;;
116   stop)
117         stop
118         ;;
119   restart)
120         restart
121         ;;
122   reload)
123         reload
124         ;;
125   condrestart)
126         [ -f /var/lock/subsys/asterisk ] && restart || :
127         ;;
128   status)
129         status asterisk
130         ;;
131   *)
132         echo "Usage: asterisk {start|stop|restart|reload|condrestart|status}"
133         exit 1
134 esac
135
136 exit $?